Index: channels/chan_agent.c
===================================================================
--- channels/chan_agent.c	(revision 95956)
+++ channels/chan_agent.c	(working copy)
@@ -275,7 +275,7 @@
 	parse = ast_strdupa(agent);
 
 	/* Extract username (agt), password and name from agent (args). */
-	AST_NONSTANDARD_APP_ARGS(args, parse, ',');
+	AST_STANDARD_APP_ARGS(args, parse);
 
 	if(args.argc == 0) {
 		ast_log(LOG_WARNING, "A blank agent line!\n");
Index: apps/app_rpt.c
===================================================================
--- apps/app_rpt.c	(revision 95956)
+++ apps/app_rpt.c	(working copy)
@@ -968,7 +968,7 @@
 			ast_copy_string(rpt_vars[n].p.tonezone, var->value, sizeof(rpt_vars[n].p.tonezone));
 		} else if (!strcmp(var->name, "tailmessagelist")) {
 			rpt_vars[n].p.tailmsgbuf = ast_strdup(var->value);
-			AST_NONSTANDARD_APP_ARGS(rpt_vars[n].p.tailmsg, rpt_vars[n].p.tailmsgbuf, ',');
+			AST_STANDARD_APP_ARGS(rpt_vars[n].p.tailmsg, rpt_vars[n].p.tailmsgbuf);
 		} else if (!strcmp(var->name, "memory")) {
 			ast_copy_string(rpt_vars[n].p.memory, var->value, sizeof(rpt_vars[n].p.memory));
 		} else if (!strcmp(var->name, "macro")) {
@@ -1005,7 +1005,7 @@
 #ifdef	__RPT_NOTCH
 		} else if (!strcmp(var->name, "rxnotch")) {
 			char *tmp = ast_strdupa(val);
-			AST_NONSTANDARD_APP_ARGS(strs, tmp, ',');
+			AST_STANDARD_APP_ARGS(strs, tmp);
 			strs.argc &= ~1; /* force an even number, rounded down */
 			if (strs.argc >= 2) {
 				for (j = 0; j < strs.argc; j += 2) {
@@ -2881,7 +2881,7 @@
 			break;
 		}
 		s = ast_strdupa(val);
-		AST_NONSTANDARD_APP_ARGS(args, s, ',');
+		AST_STANDARD_APP_ARGS(args, s);
 		rpt_mutex_lock(&myrpt->lock);
 		l = myrpt->links.next;
 		/* try to find this one in queue */
@@ -2989,7 +2989,7 @@
 			break;
 		}
 		s = ast_strdupa(val);
-		AST_NONSTANDARD_APP_ARGS(args, s, ',');
+		AST_STANDARD_APP_ARGS(args, s);
 		rpt_mutex_lock(&myrpt->lock);
 		l = myrpt->links.next;
 		/* try to find this one in queue */
@@ -3176,7 +3176,7 @@
 		if (param) {
 			/* Process parameter list */
 			char *tmp = ast_strdupa(param);
-			AST_NONSTANDARD_APP_ARGS(params, tmp, ',');
+			AST_STANDARD_APP_ARGS(params, tmp);
 			for (i = 0; i < params.argc; i++) {
 				index = matchkeyword(params.list[i], &value, keywords);
 				if (value)
@@ -3461,7 +3461,7 @@
 
 	/* Found a match, retrieve value part and parse */
 	stringp = ast_strdupa(vp->value);
-	AST_NONSTANDARD_APP_ARGS(args, stringp, ',');
+	AST_STANDARD_APP_ARGS(args, stringp);
 
 	ast_debug(1, "@@@@ action: %s, param = %s\n", args.action, S_OR(args.param, "(null)"));
 	/* Look up the action */
@@ -4677,7 +4677,7 @@
 			return DC_COMPLETE;
 		}
 		s = ast_strdupa(val);
-		AST_NONSTANDARD_APP_ARGS(args1, s, ',');
+		AST_STANDARD_APP_ARGS(args1, s);
 		if (args1.argc < 3)
 			return DC_ERROR;
 		ast_copy_string(myrpt->freq, args1.freq, sizeof(myrpt->freq));
@@ -5450,7 +5450,7 @@
 	remque((struct qelem *) l);
 	rpt_mutex_unlock(&myrpt->lock);
 	s = ast_strdupa(val);
-	AST_NONSTANDARD_APP_ARGS(args, s, ',');
+	AST_STANDARD_APP_ARGS(args, s);
 
 	/* XXX This section doesn't make any sense.  Why not just use args.channel? XXX */
 	snprintf(deststr, sizeof(deststr), "IAX2/%s", args.channel);
Index: funcs/func_strings.c
===================================================================
--- funcs/func_strings.c	(revision 95956)
+++ funcs/func_strings.c	(working copy)
@@ -379,7 +379,7 @@
 		hashkeys_read(chan, "HASHKEYS", arg.hashname, colnames, sizeof(colnames));
 		pbx_builtin_setvar_helper(chan, "~ODBCFIELDS~", colnames);
 
-		AST_NONSTANDARD_APP_ARGS(arg2, colnames, ',');
+		AST_STANDARD_APP_ARGS(arg2, colnames);
 		*buf = '\0';
 
 		/* Now get the corresponding column values, in exactly the same order */
Index: funcs/func_odbc.c
===================================================================
--- funcs/func_odbc.c	(revision 95956)
+++ funcs/func_odbc.c	(working copy)
@@ -606,7 +606,7 @@
 		AST_DECLARE_APP_ARGS(write,
 			AST_APP_ARG(dsn)[5];
 		);
-		AST_NONSTANDARD_APP_ARGS(write, tmp2, ',');
+		AST_STANDARD_APP_ARGS(write, tmp2);
 		for (i = 0; i < 5; i++) {
 			if (!ast_strlen_zero(write.dsn[i]))
 				ast_copy_string((*query)->writehandle[i], write.dsn[i], sizeof((*query)->writehandle[i]));
@@ -618,7 +618,7 @@
 		AST_DECLARE_APP_ARGS(read,
 			AST_APP_ARG(dsn)[5];
 		);
-		AST_NONSTANDARD_APP_ARGS(read, tmp2, ',');
+		AST_STANDARD_APP_ARGS(read, tmp2);
 		for (i = 0; i < 5; i++) {
 			if (!ast_strlen_zero(read.dsn[i]))
 				ast_copy_string((*query)->readhandle[i], read.dsn[i], sizeof((*query)->readhandle[i]));