Index: build_tools/menuselect-deps.in
===================================================================
--- build_tools/menuselect-deps.in	(revision 96691)
+++ build_tools/menuselect-deps.in	(working copy)
@@ -2,15 +2,12 @@
 CURL=@PBX_CURL@
 FREETDS=@PBX_FREETDS@
 GSM=@PBX_GSM@
-GTK=@PBX_GTK@
-GTK2=@PBX_GTK2@
 H323=@PBX_H323@
 OPENH323=@PBX_OPENH323@
 ICONV=@PBX_ICONV@
 IKSEMEL=@PBX_IKSEMEL@
 IMAP_TK=@PBX_IMAP_TK@
 IXJUSER=@PBX_IXJUSER@
-KDE=@PBX_KDE@
 LTDL=@PBX_LTDL@
 LUA=@PBX_LUA@
 NBS=@PBX_NBS@
@@ -24,7 +21,6 @@
 PORTAUDIO=@PBX_PORTAUDIO@
 PRI=@PBX_PRI@
 SS7=@PBX_SS7@
-QT=@PBX_QT@
 RADIUS=@PBX_RADIUS@
 SPEEX=@PBX_SPEEX@
 SQLITE=@PBX_SQLITE@
Index: configure.ac
===================================================================
--- configure.ac	(revision 96691)
+++ configure.ac	(working copy)
@@ -208,13 +208,10 @@
 AST_EXT_LIB_SETUP([CURSES], [curses], [curses])
 AST_EXT_LIB_SETUP([CRYPTO], [OpenSSL Cryptography support], [crypto])
 AST_EXT_LIB_SETUP([GSM], [External GSM library], [gsm], [, use 'internal' GSM otherwise])
-AST_EXT_LIB_SETUP([GTK], [gtk libraries], [gtk])
-AST_EXT_LIB_SETUP([GTK2], [gtk2 libraries], [gtk2])
 AST_EXT_LIB_SETUP([ICONV], [Iconv Library], [iconv])
 AST_EXT_LIB_SETUP([IKSEMEL], [Iksemel Jabber Library], [iksemel])
 AST_EXT_LIB_SETUP([IMAP_TK], [UW IMAP Toolkit], [imap])
 AST_EXT_LIB_SETUP([ISDNNET], [ISDN4Linux Library], [isdnnet])
-AST_EXT_LIB_SETUP([KDE], [KDE], [kde])
 AST_EXT_LIB_SETUP([LTDL], [libtool], [ltdl])
 AST_EXT_LIB_SETUP([LUA], [Lua], [lua])
 AST_EXT_LIB_SETUP([MISDN], [mISDN User Library], [misdn])
@@ -233,7 +230,6 @@
 AST_EXT_LIB_SETUP([SS7], [ISDN SS7], [ss7])
 AST_EXT_LIB_SETUP([PWLIB], [PWlib], [pwlib])
 AST_EXT_LIB_SETUP([OPENH323], [OpenH323], [h323])
-AST_EXT_LIB_SETUP([QT], [Qt], [qt])
 AST_EXT_LIB_SETUP([RADIUS], [Radius Client], [radius])
 AST_EXT_LIB_SETUP([SPEEX], [Speex], [speex])
 AST_EXT_LIB_SETUP([SQLITE], [SQLite], [sqlite])
@@ -811,55 +807,6 @@
 # Needed by unixodbc
 AST_EXT_LIB_CHECK([LTDL], [ltdl], [lt_dlinit], [ltdl.h], [])
 
-AC_LANG_PUSH(C++)
-
-if test "${USE_KDE}" != "no"; then
-   AC_MSG_CHECKING(for crashHandler in -lkdecore)
-   saved_libs="${LIBS}"
-   saved_cppflags="${CPPFLAGS}"
-   CPPFLAGS="${CPPFLAGS} -I${KDE_DIR}/include"
-   if test -d ${KDE_DIR}/lib; then
-      kdelibdir="${KDE_DIR}/lib"
-   else
-      kdelibdir="${KDE_DIR}"
-   fi
-   LIBS="${LIBS} -L${kdelibdir} -lkdecore"
-
-   AC_LINK_IFELSE(
-	[AC_LANG_PROGRAM(
-			[#include "kcrash.h"],
-			[KCrash::defaultCrashHandler(1);])
-	],
-	[ac_cv_lib_kde_crash="yes"],
-	[ac_cv_lib_kde_crash="no"])
-		
-   LIBS="${saved_libs}"
-   CPPFLAGS="${saved_cppflags}"
-	
-   if test "${ac_cv_lib_kde_crash}" = "yes"; then
-      AC_MSG_RESULT(yes) 
-      KDE_LIB="-lkdecore -lkdeui"
-      if test "${KDE_DIR}" != ""; then
-      	 KDE_LIB="-L${kdelibdir} ${KDE_LIB}"
-	 KDE_INCLUDE="-I${KDE_DIR}/include"
-      fi
-      PBX_KDE=1
-      AC_DEFINE([HAVE_LIBKDE], 1, [Define if your system has the KDE libraries.])
-   else
-      AC_MSG_RESULT(no) 
-   fi
-fi
-if test "${PBX_KDE}" = 1; then
-   AC_PATH_TOOL(KDEINIT, kdeinit, No)
-   if test ! x"${KDEINIT}" = xNo; then
-      KDEDIR=$(${DIRNAME} ${KDEINIT})
-      KDEDIR=$(${DIRNAME} ${KDEDIR})
-   fi
-   AC_SUBST([KDEDIR])
-fi
-
-AC_LANG_POP
-
 AST_EXT_LIB_CHECK([MISDN], [mISDN], [mISDN_open], [mISDNuser/mISDNlib.h])
 
 if test "${PBX_MISDN}" = 1; then
@@ -980,70 +927,6 @@
 		[${PWLIB_INCLUDE}], [${PWLIB_LIB}])
 fi
 
-AC_LANG_PUSH(C++)
-
-if test "${USE_QT}" != "no"; then
-   AC_MSG_CHECKING(for QDate in -lqt)
-   saved_libs="${LIBS}"
-   saved_cppflags="${CPPFLAGS}"
-   if test "x${QT_DIR}" != "x"; then
-      LIBS="${LIBS} -L${QT_DIR}/lib"
-      CPPFLAGS="${CPPFLAGS} -I${QT_DIR}/include"
-   fi
-   LIBS="${LIBS} -lqt"
-   qtlib="qt"
-   AC_LINK_IFELSE(
-	[
-		AC_LANG_PROGRAM(
-		[#include <qt3/qdatetime.h>],
-		[QDate date();])
-	],
-	[ac_cv_lib_qt_qt_date="yes"],
-	[ac_cv_lib_qt_qt_date="no"])
-   LIBS="${saved_libs}"
-   CPPFLAGS="${saved_cppflags}"
-	
-   if test "${ac_cv_lib_qt_qt_date}" = "no"; then
-      saved_libs="${LIBS}"
-      saved_cppflags="${CPPFLAGS}"
-      if test "x${QT_DIR}" != "x"; then
-      	 LIBS="${LIBS} -L${QT_DIR}/lib"
-	 CPPFLAGS="${CPPFLAGS} -I${QT_DIR}/include"
-      fi
-      LIBS="${LIBS} -lqt-mt"
-      qtlib="qt-mt"	
-      AC_LINK_IFELSE(
-		[
-			AC_LANG_PROGRAM(
-			[#include <qt3/qdatetime.h>],
-			[QDate date();])
-		],
-		[ac_cv_lib_qt_qt_date="yes"],
-		[ac_cv_lib_qt_qt_date="no"])
-      LIBS="${saved_libs}"
-      CPPFLAGS="${saved_cppflags}"
-   fi	
-
-   if test "${ac_cv_lib_qt_qt_date}" = "yes"; then
-      AC_MSG_RESULT(yes) 
-   else
-      AC_MSG_RESULT(no) 
-   fi
-	
-   if test "${ac_cv_lib_qt_qt_date}" = "yes"; then
-      QT_LIB="-l${qtlib}"
-      if test "${QT_DIR}" != ""; then
-      	 QT_LIB="-L${QT_DIR}/lib ${QT_LIB}"
-	 QT_INCLUDE="-I${QT_DIR}/include"
-      fi
-      PBX_QT=1
-      AC_DEFINE([HAVE_QT], 1, [Define if your system has the Qt library])
-      AC_PATH_TOOL(QTMOC, moc, No)
-   fi
-fi
-
-AC_LANG_POP
-
 LUA_INCLUDE="-I/usr/include/lua5.1"
 LUA_LIB="-llua5.1"
 AST_EXT_LIB_CHECK([LUA], [lua5.1], [luaL_newstate], [lua5.1/lua.h]) 
@@ -1225,21 +1108,6 @@
 AST_EXT_LIB_CHECK([X11], [X11], [XOpenDisplay], [X11/Xlib.h],,, [standard_path])
 AST_EXT_LIB_CHECK([X11], [X11], [XOpenDisplay], [X11/Xlib.h],, [-I/usr/X11R6/include], [X11R6])
 
-# we don't use gtk right now...
-AST_EXT_TOOL_CHECK([GTK], [gtk])
-
-PBX_GTK2=0
-AC_CHECK_TOOL(PKGCONFIG, pkg-config, No)
-if test ! "x${PKGCONFIG}" = xNo; then
-   GTK2_INCLUDE=$(${PKGCONFIG} gtk+-2.0 --cflags 2>/dev/null)
-   GTK2_LIB=$(${PKGCONFIG} gtk+-2.0 --libs)
-   PBX_GTK2=1
-   AC_DEFINE([HAVE_GTK2], 1, [Define if your system has the GTK2 libraries.])
-fi
-AC_SUBST(PBX_GTK2)
-AC_SUBST(GTK2_INCLUDE)
-AC_SUBST(GTK2_LIB)
-
 if test "${USE_CURL}" != "no"; then
    AC_PATH_TOOL([CURL_CONFIG], [curl-config], No)
    if test ! x"${CURL_CONFIG}" = xNo; then
Index: include/asterisk/autoconfig.h.in
===================================================================
--- include/asterisk/autoconfig.h.in	(revision 96691)
+++ include/asterisk/autoconfig.h.in	(working copy)
@@ -318,12 +318,6 @@
 /* Define to indicate that gsm.h has no prefix for its location */
 #undef HAVE_GSM_HEADER
 
-/* Define if your system has the GTK libraries. */
-#undef HAVE_GTK
-
-/* Define if your system has the GTK2 libraries. */
-#undef HAVE_GTK2
-
 /* Define this to indicate the ${ICONV_DESCRIP} library */
 #undef HAVE_ICONV
 
@@ -370,9 +364,6 @@
 /* Define to 1 if you have the <libintl.h> header file. */
 #undef HAVE_LIBINTL_H
 
-/* Define if your system has the KDE libraries. */
-#undef HAVE_LIBKDE
-
 /* Define to 1 if you have the <limits.h> header file. */
 #undef HAVE_LIMITS_H
 
@@ -604,9 +595,6 @@
 /* Define if your system has the PWLib libraries. */
 #undef HAVE_PWLIB
 
-/* Define if your system has the Qt library */
-#undef HAVE_QT
-
 /* Define this to indicate the ${RADIUS_DESCRIP} library */
 #undef HAVE_RADIUS
 
Index: makeopts.in
===================================================================
--- makeopts.in	(revision 96691)
+++ makeopts.in	(working copy)
@@ -17,7 +17,6 @@
 ID=@ID@
 SHELL=@SHELL@
 LN=@LN@
-QTMOC=@QTMOC@
 DOT=@DOT@
 STRIP=@STRIP@
 WGET=@WGET@
@@ -84,13 +83,6 @@
 GSM_INCLUDE=@GSM_INCLUDE@
 GSM_LIB=@GSM_LIB@
 
-GTK_INCLUDE=@GTK_INCLUDE@
-GTK_LIB=@GTK_LIB@
-
-GTK2_INCLUDE=@GTK2_INCLUDE@
-GTK2_LIB=@GTK2_LIB@
-
-
 ICONV_INCLUDE=@ICONV_INCLUDE@
 ICONV_LIB=@ICONV_LIB@
 
@@ -100,10 +92,6 @@
 IMAP_TK_INCLUDE=@IMAP_TK_INCLUDE@
 IMAP_TK_LIB=@IMAP_TK_LIB@
 
-KDEDIR=@KDEDIR@
-KDE_INCLUDE=@KDE_INCLUDE@
-KDE_LIB=@KDE_LIB@
-
 LUA_INCLUDE=@LUA_INCLUDE@
 LUA_LIB=@LUA_LIB@
 
@@ -149,9 +137,6 @@
 PWLIB_INCLUDE=@PWLIB_INCLUDE@
 PWLIB_LIB=@PWLIB_LIB@
 
-QT_INCLUDE=@QT_INCLUDE@
-QT_LIB=@QT_LIB@
-
 RADIUS_INCLUDE=@RADIUS_INCLUDE@
 RADIUS_LIB=@RADIUS_LIB@
 
Index: configs/modules.conf.sample
===================================================================
--- configs/modules.conf.sample	(revision 96691)
+++ configs/modules.conf.sample	(working copy)
@@ -21,14 +21,6 @@
 ; Uncomment the following if you wish to use the Speech Recognition API
 ;preload => res_speech.so
 ;
-; If you want, load the GTK console right away.  
-; Don't load the KDE console since
-; it's not as sophisticated right now.
-;
-noload => pbx_gtkconsole.so
-;load => pbx_gtkconsole.so
-noload => pbx_kdeconsole.so
-;
 load => res_musiconhold.so
 ;
 ; Load one of: chan_oss, alsa, or console (portaudio).